#include "../wj_lidar/wj_lidar_encapsulation.h"
// #include <pcl/visualization/cloud_viewer.h>
#include <fstream>
#include <sys/types.h>
#include <sys/stat.h>
#include <stdint.h>

void save_cloud_txt(std::string txt, pcl::PointCloud<pcl::PointXYZ>::Ptr pCloud)
{
    std::ofstream os;
    os.open(txt, std::ios::out);
    for (int i = 0; i < pCloud->points.size(); i++)
    {
        pcl::PointXYZ point = pCloud->points[i];
        char buf[255];
        memset(buf, 0, 255);
        sprintf(buf, "%f %f %f\n", point.x, point.y, point.z);
        os.write(buf, strlen(buf));
    }
    os.close();
}

int main(int argc,char* argv[]){
    Wj_lidar_encapsulation* lidar = new Wj_lidar_encapsulation();
    wj::wjLidarParams params;
    params.mutable_net_config()->set_ip_address("127.0.0.1");
    params.mutable_net_config()->set_port(8100);
    if(lidar!=0){
        Error_manager code = lidar->initialize(params);
        LOG(INFO) << code.to_string();
        if(code == SUCCESS){
            pcl::PointCloud<pcl::PointXYZ>::Ptr cloud = pcl::PointCloud<pcl::PointXYZ>::Ptr(new pcl::PointCloud<pcl::PointXYZ>);
            for (size_t i = 0; i < 10; i++)
            {
                code = lidar->get_cloud(cloud, std::chrono::steady_clock::now(), 3000);
                if(code == SUCCESS){
                    save_cloud_txt("cloud.txt", cloud);
                    LOG(INFO) << "cloud saved to clout.txt";
                }else{
                    LOG(WARNING) << code.to_string();
                }
                usleep(1000 * 1000);
            }
        }
    }
    getchar();
    return 0;
}